## synfig 1.4.2

=== gtkmm-osx/Makefile ===
#export


# Directories
#ROOT_DIR=/Users/darco/Projects/GTK
ROOT_DIR=$(shell pwd)
PREFIX_DIR=$(ROOT_DIR)/output
#PREFIX_DIR=/Applications/SynfigStudio.app/Contents/synfig
PACKAGETMP_DIR=$(ROOT_DIR)/pkg_out
#PREFIX_DIR=/usr/local

GETTEXT_VER=0.14.5
GETTEXT_DIR=$(ROOT_DIR)/gettext-$(GETTEXT_VER)
GETTEXT_DL=http://mirrors.kernel.org/gnu/gettext/gettext-$(GETTEXT_VER).tar.gz

LIBICONV_VER=1.9.1
LIBICONV_DIR=$(ROOT_DIR)/libiconv-$(LIBICONV_VER)
LIBICONV_DL=http://mirrors.kernel.org/gnu/libiconv/libiconv-$(GETTEXT_VER).tar.gz

GLIB_VER=2.4.7
GLIB_VER=2.8.6
GLIB_DIR=$(ROOT_DIR)/glib-$(GLIB_VER)
GLIB_DL=ftp://ftp.gtk.org/pub/gtk/v2.8/glib-$(GLIB_VER).tar.bz2

PANGO_VER=1.4.1
PANGO_VER=1.10.4
PANGO_DIR=$(ROOT_DIR)/pango-$(PANGO_VER)
PANGO_DL=http://ftp.gtk.org/pub/gtk/v2.8/pango-$(PANGO_VER).tar.bz2

CAIRO_VER=1.0.2
CAIRO_DIR=$(ROOT_DIR)/cairo-$(CAIRO_VER)
CAIRO_DL=http://cairographics.org/releases/cairo-$(CAIRO_VER).tar.gz

ATK_VER=1.6.1
ATK_VER=1.10.3
ATK_DIR=$(ROOT_DIR)/atk-$(ATK_VER)
ATK_DL=http://ftp.gtk.org/pub/gtk/v2.8/atk-$(ATK_VER).tar.bz2

GTK_VER=2.4.13
GTK_VER=2.8.13
GTK_DIR=$(ROOT_DIR)/gtk+-$(GTK_VER)
GTK_DL=http://ftp.gtk.org/pub/gtk/v2.8/gtk+-$(GTK_VER).tar.bz2

LIBPNG_VER=1.2.10
LIBPNG_DIR=$(ROOT_DIR)/libpng-$(LIBPNG_VER)
LIBPNG_DL=ftp://ftp.simplesystems.org/pub/libpng/png/src/libpng-$(LIBPNG_VER).tar.bz2

LIBJPEG_VER=6b
LIBJPEG_DIR=$(ROOT_DIR)/jpeg-$(LIBJPEG_VER)

LIBTIFF_VER=3.5.7
LIBTIFF_DIR=$(ROOT_DIR)/tiff-v$(LIBTIFF_VER)

LIBSIGC_DIR=$(ROOT_DIR)/libsigc++-1.2.4
#LIBSIGC2_DIR=$(ROOT_DIR)/libsigc++-2.0.5

LIBSIGC2_VER=2.0.16
LIBSIGC2_DIR=$(ROOT_DIR)/libsigc++-$(LIBSIGC2_VER)
LIBSIGC2_DL=http://ftp.gnome.org/pub/GNOME/sources/libsigc++/2.0/libsigc++-$(LIBSIGC2_VER).tar.gz


GLIBMM_VER=2.4.5
GLIBMM_VER=2.8.5
GLIBMM_DIR=$(ROOT_DIR)/glibmm-$(GLIBMM_VER)
GLIBMM_DL=http://ftp.gnome.org/pub/GNOME/sources/glibmm/2.8/glibmm-$(GLIBMM_VER).tar.gz

GTKMM_VER=2.4.7
GTKMM_VER=2.8.3
GTKMM_DIR=$(ROOT_DIR)/gtkmm-$(GTKMM_VER)
GTKMM_DL=http://ftp.gnome.org/pub/GNOME/sources/gtkmm/2.8/gtkmm-$(GTKMM_VER).tar.gz

LIBXML2_VER=2.6.23
LIBXML2_DIR=$(ROOT_DIR)/libxml2-$(LIBXML2_VER)

LIBXMLPP_VER=1.0.4
LIBXMLPP_DIR=$(ROOT_DIR)/libxml++-$(LIBXMLPP_VER)
LIBXMLPP_DL=http://ftp.gnome.org/pub/GNOME/sources/libxml++/1.0/libxml++-$(LIBXMLPP_VER).tar.gz


FONTCONFIG_VER=2.2.96
FONTCONFIG_DIR=$(ROOT_DIR)/fontconfig-$(FONTCONFIG_VER)

INSTALL_PREFIX=/usr/local

# Other
prefix="$(PREFIX_DIR)"
TEMP_FILE=$(ROOT_DIR)/tempfile.xxx
PKG_CONFIG_PATH="$(PREFIX_DIR)"/lib/pkgconfig:/usr/X11R6/lib/pkgconfig:/usr/lib/pkgconfig
PREFIX_SYMBOL=@PREFIX@

#export DYLD_LIBRARY_PATH="$(PREFIX_DIR)"/lib:/lib:/usr/local/lib:/lib:/usr/lib
export LD_PREBIND=1
export LD_PREBIND_ALLOW_OVERLAP=1
export LD_PREBIND_ALL_TWOLEVEL_MODULES=1
export MACOSX_DEPLOYMENT_TARGET=10.4
export CPP=gcc -E

# Programs
#MAKE=export MACOSX_DEPLOYMENT_TARGET=$(MACOSX_DEPLOYMENT_TARGET) && make
MAKE=make -j2
CP=cp
MV=mv
MKDIR=mkdir
GREP=grep
STRIP=strip
FIND=find
CHMOD=chmod
PRINTF=printf
SED=/sw/bin/sed
PACKAGE=./package
CURL=curl -f
UNTARZ=tar xvzf
UNTARJ=tar xvjf
CAT=cat

OFLAGS=
ARCHFLAGS=-arch i386 -arch ppc

#ARCHFLAGS=-arch i386

#OFLAGS=-faltivec -maltivec
#ARCHFLAGS=-arch ppc

CFLAGS=-I"$(PREFIX_DIR)"/include -no-cpp-precomp $(OFLAGS) $(ARCHFLAGS)
CC=gcc $(CFLAGS)
CC3=gcc $(CFLAGS)
CXXFLAGS=$(CFLAGS)
CXX=g++ $(CXXFLAGS)
CXXCPP=g++ -E
CPP=gcc -E
LDFLAGS=$(ARCHFLAGS) -L"$(PREFIX_DIR)"/lib -prebind_all_twolevel_modules -twolevel_namespace -bind_at_load -undefined dynamic_lookup
LFLAGS=$(LDFLAGS)


DESTDIR_FIX=for filename in `$(FIND) . | $(GREP) Makefile | $(GREP) -v -e Makefile.am -e Makefile.in` ; do { echo Patching $$filename ... && sed 's:LIBDIR=\\"$$(libdir)\\":LIBDIR=\\"$(INSTALL_PREFIX)/lib\\":g;s:DATA_PREFIX=\\"$$(prefix)\\":DATA_PREFIX=\\"$(INSTALL_PREFIX)\\":g; s:LOCALEDIR=\\"$$(localedir)\\":LOCALEDIR=\\"$(INSTALL_PREFIX)/share/locale\\":g; s:LOCALE_ALIAS_PATH=\\"$$(aliaspath)\\":LOCALE_ALIAS_PATH=\\"$(INSTALL_PREFIX)/share/locale\\":g;s:SYSCONFDIR=\\"$$(sysconfdir)\\":SYSCONFDIR=\\"$(INSTALL_PREFIX)/etc\\":g;' < $$filename > $(TEMP_FILE) && cp $(TEMP_FILE) $$filename ; } ; done ; 

ENDIAN_FIX=$(PRINTF) "\#ifdef __BIG_ENDIAN__\n\
\#define WORDS_BIGENDIAN\n\
\#endif\n\
\#undef G_ATOMIC_I486\n\
\#undef G_ATOMIC_POWERPC\n\
\#ifdef __i386__\n\
\#define G_ATOMIC_I486\n\
\#endif\n\
\#ifdef __ppc__\n\
\#define G_ATOMIC_POWERPC\n\
\#endif\n\
" >> config.h

ENVIRONMENT="ARCHFLAGS=$(ARCHFLAGS)" "CC=$(CC)" "CXX=$(CXX)" "CXXCPP=$(CXXCPP)" "CPP=$(CPP)" "PKG_CONFIG_PATH=$(PKG_CONFIG_PATH)" "LDFLAGS=$(LDFLAGS)" "MACOSX_DEPLOYMENT_TARGET=$(MACOSX_DEPLOYMENT_TARGET)"

# Flags
CONFIG_FLAGS=--prefix="$(PREFIX_DIR)" --disable-static --enable-shared $(ENVIRONMENT)

# Targets
all: gettext glib libpng libjpeg cairo pango atk gtk libsigc2 glibmm gtkmm libxmlpp

packages: gettext-pkg glib-pkg pango-pkg atk-pkg libpng-pkg libjpeg-pkg cairo-pkg gtk-pkg libsigc2-pkg glibmm-pkg gtkmm-pkg libxmlpp-pkg
clean: gettext-clean glib-clean libpng-clean libjpeg-clean cairo-clean pango-clean atk-clean gtk-clean libsigc2-clean glibmm-clean gtkmm-clean libxmlpp-clean
	$(RM) -r gtkmm.pkg

clean-all: clean
	$(RM) -r output

strip:
	$(STRIP) "$(PREFIX_DIR)"/lib/*.dylib

setup-uninstall:
	$(PRINTF) "\
#!/bin/bash\n\
cd @PREFIX@\n\
sudo for file in "'`'"cat bin/uninstall_gtk_list.txt"'`'"\n\
do\n\
	printf .\n\
	rm $$file\n\
done\n\
" > "$(PREFIX_DIR)"/bin/uninstall_gtk
	$(CHMOD) +x "$(PREFIX_DIR)"/bin/uninstall_gtk
	cd "$(PREFIX_DIR)" && find . | tac > bin/uninstall_gtk_list.txt

#PACKAGE_PREP="for filename in `find . | $(GREP) -e '\.la' -e '\.pc' -e '[-]config' -e '\.loaders' -e '\.immodules'` ; do [ -d $$filename ] || { $(GREP) -l '$(ROOT_DIR)' $$filename && $(SED) 's;"$(PREFIX_DIR)";@PREFIX@;g;s:-L$(ROOT_DIR)/gettext-0.11.5/intl::g;' < $$filename > $(TEMP_FILE) && $(CP) $(TEMP_FILE) $$filename ;} ; done; $(RM) $(TEMP_FILE)"

PACKAGE_PREP=for filename in `find | $(GREP) -e '\.la' -e '\.pc' -e '[-]config' -e '\.loaders' -e '\.immodules'` ; do [ -d $$filename ] || { $(SED) 's;$(PACKAGETMP_DIR);@PREFIX@;g;s;"$(PREFIX_DIR)";@PREFIX@;g;s:-L$(ROOT_DIR)/gettext-0.11.5/intl::g;' < $$filename > $(TEMP_FILE) && $(CP) $(TEMP_FILE) $$filename && echo $$filename ;} ; done; $(RM) $(TEMP_FILE) ; $(RM) -R share/doc

package-prep: setup-uninstall
	-cd "$(PREFIX_DIR)" && $(PACKAGE_PREP)	
#	-cd "$(PREFIX_DIR)" && for filename in `$(CAT) "$(PREFIX_DIR)"/bin/uninstall_gtk_list.txt | $(GREP) -e "\.la" -e "\.pc" -e -config -e "\.loaders" -e "\.immodules"` ;\
#		do [ -d $$filename ] || { \
#			$(GREP) -l "$(ROOT_DIR)" $$filename && \
#			$(SED) "s;"$(PREFIX_DIR)";@PREFIX@;g;s:-L$(ROOT_DIR)/gettext-0.11.5/intl::g;" \
#			< $$filename > $(TEMP_FILE) && \
#			$(CP) $(TEMP_FILE) $$filename \
#	;} ; done
#	$(RM) $(TEMP_FILE)


package:
	$(PACKAGE) "$(PREFIX_DIR)" gtkmm.info -r PkgResource -bzip
#	-[ -d gtkmm.xpm ] && mv gtkmm.xpm gtkmm.pkg

gettext: gettext-$(GETTEXT_VER)
	cd $(GETTEXT_DIR) && ./configure $(CONFIG_FLAGS) "LDFLAGS=$(LDFLAGS) -L$(GETTEXT_DIR)/intl" --with-libiconv-prefix=/usr/lib
	cd $(GETTEXT_DIR) && $(ENDIAN_FIX)
#	$(SED) "s/__USER_LABEL_PREFIX__/_/g;" < $(GETTEXT_DIR)/intl/libgnuintl.h > $(TEMP_FILE)
#	$(CP) $(TEMP_FILE) $(GETTEXT_DIR)/intl/libgnuintl.h
#	$(RM) $(TEMPFILE)
#cd $(GETTEXT_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(GETTEXT_DIR)
	$(MAKE) -C $(GETTEXT_DIR) install

gettext-pkg:
	$(RM) -r $(ROOT_DIR)/pkg_out
	$(MAKE) -C $(GETTEXT_DIR) install-strip prefix=$(ROOT_DIR)/pkg_out
	-cd $(ROOT_DIR)/pkg_out && $(PACKAGE_PREP)
	$(SED) "s/@PACKAGE@/gettext/g;s/@VERSION@/$(GETTEXT_VER)/;" < package.info > gettext.info
	$(PACKAGE) $(ROOT_DIR)/pkg_out gettext.info -r PkgResource -bzip
	$(RM) -r $(ROOT_DIR)/pkg_out
	mv $(ROOT_DIR)/gettext.pkg packages

gettext-clean:
	$(MAKE) -C $(GETTEXT_DIR) clean

gettext-$(GETTEXT_VER):
	$(CURL) $(GETTEXT_DL) -o gettext-$(GETTEXT_VER).tar.gz
	$(UNTARZ) gettext-$(GETTEXT_VER).tar.gz
	
libiconv:
	cd $(LIBICONV_DIR) && ./configure $(CONFIG_FLAGS)
	cd $(LIBICONV_DIR) && $(ENDIAN_FIX)
	cd $(LIBICONV_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(LIBICONV_DIR)
	$(MAKE) -C $(LIBICONV_DIR) install

libiconv-clean:
	$(MAKE) -C $(LIBICONV_DIR) clean

glib: glib-$(GLIB_VER)
	cd $(GLIB_DIR) && ./configure $(CONFIG_FLAGS)
	cd $(GLIB_DIR) && $(ENDIAN_FIX)
	cd $(GLIB_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(GLIB_DIR)
	$(MAKE) -C $(GLIB_DIR) install-strip

glib-pkg:
	$(RM) -r $(ROOT_DIR)/pkg_out
	$(MAKE) -C $(GLIB_DIR) install-strip prefix=$(ROOT_DIR)/pkg_out
	-cd $(ROOT_DIR)/pkg_out && $(PACKAGE_PREP)
	$(SED) "s/@PACKAGE@/glib/g;s/@VERSION@/$(GLIB_VER)/;" < package.info > glib.info
	$(PACKAGE) $(ROOT_DIR)/pkg_out glib.info -r PkgResource -bzip
	$(RM) -r $(ROOT_DIR)/pkg_out
	mv $(ROOT_DIR)/glib.pkg packages

glib-clean:
	$(MAKE) -C $(GLIB_DIR) clean

glib-$(GLIB_VER):
	$(CURL) $(GLIB_DL) -o glib-$(GLIB_VER).tar.bz2
#	$(UNTARZ) glib-$(GLIB_VER).tar.gz
	$(UNTARJ) glib-$(GLIB_VER).tar.bz2




cairo: cairo-$(CAIRO_VER)
	cd $(CAIRO_DIR) && ./configure $(CONFIG_FLAGS)
	cd $(CAIRO_DIR) && $(ENDIAN_FIX)
	cd $(CAIRO_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(CAIRO_DIR)
	$(MAKE) -C $(CAIRO_DIR) install-strip

cairo-pkg:
	$(RM) -r $(ROOT_DIR)/pkg_out
	$(MAKE) -C $(CAIRO_DIR) install-strip prefix=$(ROOT_DIR)/pkg_out
	-cd $(ROOT_DIR)/pkg_out && $(PACKAGE_PREP)
	$(SED) "s/@PACKAGE@/cairo/g;s/@VERSION@/$(CAIRO_VER)/;" < package.info > cairo.info
	$(PACKAGE) $(ROOT_DIR)/pkg_out cairo.info -r PkgResource -bzip
	$(RM) -r $(ROOT_DIR)/pkg_out
	mv $(ROOT_DIR)/cairo.pkg packages

cairo-clean:
	$(MAKE) -C $(CAIRO_DIR) clean

cairo-$(CAIRO_VER):
	$(CURL) $(CAIRO_DL) -o cairo-$(CAIRO_VER).tar.gz
	$(UNTARZ) cairo-$(CAIRO_VER).tar.gz




pango: pango-$(PANGO_VER)
	cd $(PANGO_DIR) && ./configure $(CONFIG_FLAGS) 
	cd $(PANGO_DIR) && $(ENDIAN_FIX)
	cd $(PANGO_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(PANGO_DIR)
	$(MAKE) -C $(PANGO_DIR) install-strip

pango-pkg:
	$(RM) -r $(ROOT_DIR)/pkg_out
	$(MAKE) -C $(PANGO_DIR) install-strip prefix=$(ROOT_DIR)/pkg_out
	-cd $(ROOT_DIR)/pkg_out && $(PACKAGE_PREP)
	$(SED) "s/@PACKAGE@/pango/g;s/@VERSION@/$(PANGO_VER)/;" < package.info > pango.info
	$(PACKAGE) $(ROOT_DIR)/pkg_out pango.info -r PkgResource -bzip
	$(RM) -r $(ROOT_DIR)/pkg_out
	mv $(ROOT_DIR)/pango.pkg packages

pango-clean:
	$(MAKE) -C $(PANGO_DIR) clean

pango-$(PANGO_VER):
	$(CURL) $(PANGO_DL) -o pango-$(PANGO_VER).tar.bz2
	$(UNTARJ) pango-$(PANGO_VER).tar.bz2

atk: atk-$(ATK_VER)
	cd $(ATK_DIR) && ./configure $(CONFIG_FLAGS) 
	cd $(ATK_DIR) && $(ENDIAN_FIX)
	cd $(ATK_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(ATK_DIR)
	$(MAKE) -C $(ATK_DIR) install-strip

atk-pkg:
	$(RM) -r $(ROOT_DIR)/pkg_out
	$(MAKE) -C $(ATK_DIR) install-strip prefix=$(ROOT_DIR)/pkg_out
	-cd $(ROOT_DIR)/pkg_out && $(PACKAGE_PREP)
	$(SED) "s/@PACKAGE@/atk/g;s/@VERSION@/$(ATK_VER)/;" < package.info > atk.info
	$(PACKAGE) $(ROOT_DIR)/pkg_out atk.info -r PkgResource -bzip
	$(RM) -r $(ROOT_DIR)/pkg_out
	mv $(ROOT_DIR)/atk.pkg packages

atk-clean:
	$(MAKE) -C $(ATK_DIR) clean

atk-$(ATK_VER):
	$(CURL) $(ATK_DL) -o atk-$(ATK_VER).tar.bz2
	$(UNTARJ) atk-$(ATK_VER).tar.bz2

libpng: libpng-$(LIBPNG_VER)
	cd $(LIBPNG_DIR) && ./configure $(CONFIG_FLAGS) 
	cd $(LIBPNG_DIR) && $(ENDIAN_FIX)
	cd $(LIBPNG_DIR) && $(DESTDIR_FIX)
	$(MAKE) -C $(LIBPNG_DIR)
	$(MAKE) -C $(LIBPNG_DIR) install-strip
#	$(MAKE) -C $(LIBPNG_DIR) -f makefile.macosx prefix="$(PREFIX_DIR)" $(ENVIRONMENT)
#	$(MAKE) -C $(LIBPNG_DIR) -f makefile.macosx install prefix="$(PREFIX_DIR)" $(ENVIRONMENT)
#	$(MAKE) -C $(LIBPNG_DIR) -f makefile.macosx shared prefix="$(PREFIX_DIR)" $(ENVIRONMENT)
#	$(MAKE) -C $(LIBPNG_DIR) -f makefile.macosx install-shared prefix="$(PREFIX_DIR)" $(ENVIRONMENT)
#	$(MV) "$(PREFIX_DIR)"/lib/libpng.dylib "$(PREFIX_DIR)"/lib/libpng.dylib.xxx

libpng-pkg:
	$(RM) -r $(ROOT_DIR)/pkg_out
	$(MKDIR) $(ROOT_DIR)/pkg_out
	$(MAKE) -C $(LIBPNG_DIR) -f makefile.macosx install prefix=$(ROOT_DIR)/pkg_out
	-cd $(ROOT_DIR)/pkg_out && $(PACKAGE_PREP)
	$(SED) "s/@PACKAGE@/libpng/g;s/@VERSION@/$(LIBPNG_VER)/;" < package.info > libpng.info

=== synfig-core/CMakeLists.txt ===
# TODO: find out which version is actually required
cmake_minimum_required(VERSION 3.1)

project(synfig-core)

enable_testing()

# using latest stable standard, but not strictly
# the rest is done via target_compile_features instead
set(CMAKE_CXX_STANDARD 11)

add_subdirectory(src)

=== synfig-core/src/CMakeLists.txt ===
# TODO: find out which version is actually required
cmake_minimum_required(VERSION 3.1)

##
## Find packages
##

# TODO: check if we really need all of them
find_package(Boost REQUIRED system)

find_package(ZLIB REQUIRED)

## ETL doesn't install a package configuration so find package will fail
# find_package(ETL REQUIRED)


## TODO: investigate these more closely
set(CMAKE_THREAD_PREFER_PTHREAD ON)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
if (CMAKE_USE_PTHREADS_INIT)
    set(HAVE_LIBPTHREAD ON)
endif()

include(FindPkgConfig)
pkg_check_modules(SIGCPP REQUIRED sigc++-2.0)
pkg_check_modules(GLIBMM REQUIRED glibmm-2.4)
pkg_check_modules(GIOMM REQUIRED giomm-2.4)
pkg_check_modules(CAIRO REQUIRED cairo)
pkg_check_modules(PANGOCAIRO REQUIRED pangocairo) # lyr_freetype
pkg_check_modules(LIBXML REQUIRED libxml++-2.6)
pkg_check_modules(MLT REQUIRED mlt++)
pkg_check_modules(FFTW REQUIRED fftw3)
pkg_check_modules(FT REQUIRED freetype2) # for lyr_freetype
pkg_check_modules(LIBPNG REQUIRED libpng) # for mod_png
pkg_check_modules(LIBMNG REQUIRED libmng) # for mod_mng
pkg_check_modules(LIBJPEG REQUIRED libjpeg) # for mod_mng
pkg_check_modules(OPENEXR REQUIRED OpenEXR) # for mod_openexr
pkg_check_modules(MAGICKCORE REQUIRED MagickCore) # for Magick++

## TODO: move to module where it is actually required
pkg_check_modules(PANGO REQUIRED pango)

## TODO: should we keep it here?
find_package(ImageMagick COMPONENTS Magick++)

##
## Configure
##

## set git version
## TODO: put into separate file
find_package(Git)
if (GIT_FOUND)
    execute_process(
        COMMAND ${GIT_EXECUTABLE} show -s --format=%ad --date=format:%Y%m%d HEAD
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE GIT_DATE
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse --abbrev-ref HEAD
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE GIT_BRANCH
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    execute_process(
        COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE GIT_HASH
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else()
    set(GIT_DATE    "unknown")
    set(GIT_BRANCH  "unknown")
    set(GIT_HASH    "unknown")
endif()

# Check headers
include(CheckIncludeFile)
CHECK_INCLUDE_FILE(sys/wait.h  HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILE(signal.h    HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE(termios.h   HAVE_TERMIOS_H)
CHECK_INCLUDE_FILE(process.h   HAVE_PROCESS_H)
CHECK_INCLUDE_FILE(io.h        HAVE_IO_H)
CHECK_INCLUDE_FILE(sys/fcntl.h HAVE_FCNTL_H)

# Check functions
include (CheckFunctionExists)
CHECK_FUNCTION_EXISTS(fork HAVE_FORK)
CHECK_FUNCTION_EXISTS(pipe HAVE_PIPE)
CHECK_FUNCTION_EXISTS(waitpid HAVE_WAITPID)

add_definitions(-DHAVE_CONFIG_H)
configure_file(config.h.cmake.in config.h)
configure_file(autorevision.h.cmake.in autorevision.h)

##
## Include
##

## for config
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

##
## CMake helpers
##

include(cmake/install_header.cmake)

##
## Sub-dirs
##

add_subdirectory(synfig)
add_subdirectory(tool)
add_subdirectory(modules)

##
## Build targets
##

=== synfig-studio/images/CMakeLists.txt ===
set(IMG_SOURCE_animate_mode_off_icon animate_mode_icons 0)
set(IMG_SOURCE_animate_mode_on_icon animate_mode_icons 1)

set(IMG_SOURCE_interpolation_type_tcb_icon interpolation_type_icons 1)
set(IMG_SOURCE_interpolation_type_linear_icon interpolation_type_icons 2)
set(IMG_SOURCE_interpolation_type_ease_icon interpolation_type_icons 3)
set(IMG_SOURCE_interpolation_type_const_icon interpolation_type_icons 4)
set(IMG_SOURCE_interpolation_type_clamped_icon interpolation_type_icons 5)
# set(IMG_SOURCE_interpolation_type_unknown_icon interpolation_type_icons 6)
set(IMG_SOURCE_valuenode_forbidanimation_icon interpolation_type_icons 7)

set(IMG_SOURCE_action_doc_new_icon action_doc_icons 1)
set(IMG_SOURCE_action_doc_open_icon action_doc_icons 2)
set(IMG_SOURCE_action_doc_save_icon action_doc_icons 3)
set(IMG_SOURCE_action_doc_saveas_icon action_doc_icons 4)
set(IMG_SOURCE_action_doc_saveall_icon action_doc_icons 5)
set(IMG_SOURCE_action_doc_undo_icon action_doc_icons 6)
set(IMG_SOURCE_action_doc_redo_icon action_doc_icons 7)

set(IMG_SOURCE_canvas_icon canvas_and_importimage_icons 2)

set(IMG_SOURCE_animate_seek_next_keyframe_icon framedial_icons 0)
set(IMG_SOURCE_animate_seek_prev_keyframe_icon framedial_icons 1)
set(IMG_SOURCE_animate_seek_next_frame_icon framedial_icons 2)
set(IMG_SOURCE_animate_seek_prev_frame_icon framedial_icons 3)
set(IMG_SOURCE_animate_seek_begin_icon framedial_icons 4)
set(IMG_SOURCE_animate_seek_end_icon framedial_icons 5)
set(IMG_SOURCE_animate_play_icon framedial_icons 6)
set(IMG_SOURCE_animate_stop_icon framedial_icons 7)
set(IMG_SOURCE_animate_pause_icon framedial_icons 8)
set(IMG_SOURCE_animate_loop_icon framedial_icons 9)
set(IMG_SOURCE_animate_bounds_icon framedial_icons 10)
set(IMG_SOURCE_animate_bound_lower_icon framedial_icons 11)
set(IMG_SOURCE_animate_bound_upper_icon framedial_icons 12)

set(IMG_SOURCE_keyframe_lock_past_on_icon keyframe_lock_icons 0)
set(IMG_SOURCE_keyframe_lock_past_off_icon keyframe_lock_icons 1)
set(IMG_SOURCE_keyframe_lock_future_on_icon keyframe_lock_icons 2)
set(IMG_SOURCE_keyframe_lock_future_off_icon keyframe_lock_icons 3)

set(IMG_SOURCE_utils_chain_link_on_icon utils_chain_link_icons 0)
set(IMG_SOURCE_utils_chain_link_off_icon utils_chain_link_icons 1)

set(ICONS
    animate_mode_off_icon
    animate_mode_on_icon

    interpolation_type_tcb_icon
    interpolation_type_linear_icon
    interpolation_type_ease_icon
    interpolation_type_const_icon
    interpolation_type_clamped_icon
    valuenode_forbidanimation_icon

    action_doc_new_icon
    action_doc_open_icon
    action_doc_save_icon
    action_doc_saveas_icon
    action_doc_saveall_icon
    action_doc_undo_icon
    action_doc_redo_icon

    canvas_icon

    animate_seek_next_keyframe_icon
    animate_seek_prev_keyframe_icon
    animate_seek_next_frame_icon
    animate_seek_prev_frame_icon
    animate_seek_end_icon
    animate_seek_begin_icon
    animate_play_icon
    animate_stop_icon
    animate_pause_icon
    animate_loop_icon
    animate_bounds_icon
    animate_bound_lower_icon
    animate_bound_upper_icon

    keyframe_lock_past_on_icon
    keyframe_lock_past_off_icon
    keyframe_lock_future_on_icon
    keyframe_lock_future_off_icon

    utils_chain_link_on_icon
    utils_chain_link_off_icon

    action_add_to_set_icon
    action_export_icon
    action_flat_interpolation_icon
    action_interpolate_interpolation_icon
    action_peak_interpolation_icon
    action_remove_from_set_icon
    action_rounded_interpolation_icon
    action_set_layer_description_icon
    action_squared_interpolation_icon
    action_unexport_icon
    clear_redo_icon
    clear_undo_icon
    decr_resolution_icon
    duck_angle_icon
    duck_position_icon
    duck_radius_icon
    duck_tangent_icon
    duck_vertex_icon
    duck_width_icon
    duplicate_icon
    graphs_icon
    group_icon
    history_icon
    incr_resolution_icon
    info_icon
    jack_icon
    keyframe_icon
    layer_blur_blur_icon
    layer_blur_motion_icon
    layer_blur_radial_icon
    layer_distortion_curvewarp_icon
    layer_distortion_insideout_icon
    layer_distortion_noise_icon
    layer_distortion_spherize_icon
    layer_distortion_stretch_icon
    layer_distortion_twirl_icon
    layer_distortion_warp_icon
    layer_example_metaballs_icon
    layer_example_simplecircle_icon
    layer_filter_clamp_icon
    layer_filter_colorcorrect_icon
    layer_filter_halftone2_icon
    layer_filter_halftone3_icon
    layer_filter_lumakey_icon
    layer_fractal_julia_icon
    layer_fractal_mandelbrot_icon
    layer_geometry_advanced_outline_icon
    layer_geometry_checkerboard_icon
    layer_geometry_circle_icon
    layer_geometry_outline_icon
    layer_geometry_polygon_icon
    layer_geometry_rectangle_icon
    layer_geometry_region_icon
    layer_geometry_solidcolor_icon
    layer_geometry_star_icon
    layer_gradient_conical_icon
    layer_gradient_curve_icon
    layer_gradient_linear_icon
    layer_gradient_noise_icon
    layer_gradient_radial_icon
    layer_gradient_spiral_icon
    layer_icon
    layer_other_duplicate_icon
    layer_other_group_icon
    layer_other_plant_icon
    layer_other_skeleton_icon
    layer_other_sound_icon
    layer_other_stroboscope_icon
    layer_other_supersample_icon
    layer_other_switch_icon
    layer_other_text_icon
    layer_other_timeloop_icon
    layer_other_xorpattern_icon
    layer_stylize_bevel_icon
    layer_stylize_shade_icon
    layer_transform_rotate_icon
    layer_transform_scale_icon
    layer_transform_translate_icon
    layer_transform_zoom_icon
    library_icon
    meta_data_icon
    navigator_icon
    onion_skin_icon
    palette_icon
    parameters_icon
    preview_options_icon
    background_rendering_icon
    rename_icon
    render_options_icon
    reset_colors_icon
    select_all_child_layers_icon
    set_fill_color
    set_icon
    set_outline_color
    show_grid_icon
    show_guideline_icon
    sif_icon
    snap_grid_icon
    snap_guideline_icon
    swap_colors_icon
    time_track_icon
    tool_brush_icon
    tool_circle_icon
    tool_cutout_icon
    tool_draw_icon
    tool_eyedrop_icon
    tool_fill_icon
    tool_gradient_icon
    tool_mirror_icon
    tool_normal_icon
    tool_polyline_icon
    tool_rectangle_icon
    tool_rotate_icon
    tool_scale_icon
    tool_sketch_icon
    tool_smooth_move_icon
    tool_spline_icon
    tool_star_icon
    tool_text_icon
    tool_width_icon
    tool_zoom_icon
    type_angle_icon
    type_bool_icon
    type_canvas_icon
    type_color_icon
    type_gradient_icon
    type_integer_icon
    type_list_icon
    type_real_icon
    type_segment_icon
    type_splinepoint_icon
    type_string_icon
    type_time_icon
    type_vector_icon
    utils_timetrack_align_icon
    valuenode_icon
)

set(IMAGES
    about_icon
    logo
    splash_screen
    synfig_icon
    ${ICONS}
)

## TODO: don't run this if files are up to date
add_custom_target(build_images)

## TODO: configure icon size
foreach (ICON IN ITEMS ${ICONS})
    set(IMG_SIZE_${ICON} 32 32)
endforeach()

foreach (IMAGE IN ITEMS ${IMAGES})
    if (IMG_SOURCE_${IMAGE})
        list(GET IMG_SOURCE_${IMAGE} 0 SRC)
        list(GET IMG_SOURCE_${IMAGE} 1 TIME)
    else()
        set(SRC ${IMAGE})
        set(TIME 0)
    endif()
    if (IMG_SIZE_${IMAGE})
        list(GET IMG_SIZE_${IMAGE} 0 W)
        list(GET IMG_SIZE_${IMAGE} 1 H)
    else()
        set(W 0)
        set(H 0)
    endif()
    add_custom_command(
        TARGET build_images POST_BUILD
        COMMAND synfig ${SRC}.sif --time ${TIME}f -w ${W} -h ${H} --quiet
        COMMAND mv ${SRC}.png ${CMAKE_CURRENT_BINARY_DIR}/${IMAGE}.png
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${SRC}.sif
    )
    install(
        FILES ${CMAKE_CURRENT_BINARY_DIR}/${IMAGE}.png
        DESTINATION share/pixmaps
    )
endforeach()

=== synfig-studio/sounds/CMakeLists.txt ===
set(SOUNDS
    renderdone.wav
    readme.txt
)

foreach (SOUND IN ITEMS ${SOUNDS})
    install(
        FILES ${CMAKE_CURRENT_SOURCE_DIR}/${SOUND}
        DESTINATION share/synfig/sounds
    )
endforeach()

=== synfig-core/src/synfig/CMakeLists.txt ===
##
## Build targets
##

## Main target: libsynfig
## TODO: optional static linking?
add_library(synfig SHARED "")

message(STATUS "MLT DIR: ${MLT_INCLUDE_DIRS}")

target_include_directories(synfig
#    SYSTEM BEFORE PUBLIC
SYSTEM PUBLIC
        ${LIBXML_INCLUDE_DIRS}
PUBLIC
        ${SIGCPP_INCLUDE_DIRS}
        ${GLIBMM_INCLUDE_DIRS}
        ${GIOMM_INCLUDE_DIRS}
        ${CAIRO_INCLUDE_DIRS}
        ${PANGO_INCLUDE_DIRS}
        ${MLT_INCLUDE_DIRS}
        ${FFTW_INCLUDE_DIRS}
)

target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/activepoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/bone.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/blur.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/cairo_operators.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/cairo_renddesc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/canvas.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/context.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/curve_helper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/curveset.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/distance.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/exception.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/guid.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/importer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/cairoimporter.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/keyframe.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/layer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/loadcanvas.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/module.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/node.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/palette.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/paramdesc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/polynomial_root.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/rect.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/renddesc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/render.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/savecanvas.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/string_helper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/surface.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/time.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/timepointcollect.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/transform.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/uniqueid.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valuenode.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valuenode_registry.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/waypoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/matrix.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystem.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystemnative.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystemgroup.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filesystemtemporary.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filecontainer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/filecontainerzip.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/zstreambuf.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valueoperations.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/soundprocessor.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/canvasfilenaming.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/token.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/threadpool.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/curve.cpp"
)

## these were added seprately in autotools build, preserving this for now
## TODO: either merge with main list or create new target
target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/target_multi.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_null.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_null_tile.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_scanline.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_cairo.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_tile.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/target_cairo_tile.cpp"
)
target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/listimporter.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/cairolistimporter.cpp"
)
target_sources(synfig
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/blinepoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/widthpoint.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/dashitem.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/gradient.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/type.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/base_types.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/value.cpp"
)

##
## Sub-dirs
##

## include sub-dirs
include(color/CMakeLists.txt)
include(layers/CMakeLists.txt)
include(rendering/CMakeLists.txt)
include(valuenodes/CMakeLists.txt)

## TODO: check if we need this for release build
include(debug/CMakeLists.txt)

target_link_libraries(synfig
    PUBLIC
        ${SIGCPP_LIBRARIES}
        ${GLIBMM_LIBARIES}
        ${GIOMM_LIBRARIES}
        ${CAIRO_LIBRARIES}
        ${LIBXML_LIBRARIES}
        ${MLT_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${FFTW_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}

        # TODO: properly detect ltdl
        ltdl
)

## Install headers
## TODO: find a better way to do that, maybe?
file(GLOB SYNFIG_HEADERS "${CMAKE_CURRENT_LIST_DIR}/*.h")

install(
    FILES ${SYNFIG_HEADERS}
    DESTINATION include/synfig
)

install(
    TARGETS synfig
    EXPORT synfig
    LIBRARY DESTINATION lib
)

export(
    EXPORT synfig
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}-config.cmake"
)

install(
    EXPORT synfig
    FILE "${PROJECT_NAME}-config.cmake"
    DESTINATION "lib/cmake/${PROJECT_NAME}"
)

=== synfig-studio/src/gui/CMakeLists.txt ===
##
## Configure
##

set(STUDIO_VERSION "1.4.2")
set(SHOW_EXTRA_INFO OFF) # this needs some fixes to work
set(DATA_PREFIX "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Path, where the share directory with the pixmaps, sounds, plugins and translations is located. Default: Prefix, where Synfig Studio is going to be installed")
set(IMG_EXT "png" CACHE STRING "File extension of the pixmaps (without the \".\"). Default: png")

configure_file(autorevision.h.cmake.in autorevision.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

## Defines
add_definitions(-DIMAGE_EXT="${IMG_EXT}")
add_definitions(-DIMAGE_DIR="${DATA_PREFIX}/share/pixmaps")
add_definitions(-DSOUND_DIR="${DATA_PREFIX}/share/synfig/sounds")
add_definitions(-DPLUGIN_DIR="${DATA_PREFIX}/share/synfig/plugins")
add_definitions(-DUI_DIR="${DATA_PREFIX}/share/synfig/ui")
add_definitions(-DLOCALEDIR="${DATA_PREFIX}/share/locale")

##
## Targets
##

add_executable(synfigstudio main.cpp)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

target_sources(synfigstudio
    PRIVATE
        "${CMAKE_CURRENT_LIST_DIR}/duck.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/timemodel.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/app.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/asyncrenderer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/audiocontainer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/autorecover.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/canvasview.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/devicetracker.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/dialogsettings.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/duckmatic.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/iconcontroller.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/instance.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/ipc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/keymapsettings.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/onemoment.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/pluginmanager.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/preview.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/progresslogger.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/renddesc.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/render.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/resourcehelper.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/splash.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/statemanager.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/timeplotdata.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/valuelink.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/waypointrenderer.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/workarea.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/workspacehandler.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/main_win32.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/mainwindow.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/helpers.cpp"
)

include(actionmanagers/CMakeLists.txt)
include(cellrenderer/CMakeLists.txt)
include(dialogs/CMakeLists.txt)
include(dials/CMakeLists.txt)
include(docks/CMakeLists.txt)
include(modules/CMakeLists.txt)
include(states/CMakeLists.txt)
include(trees/CMakeLists.txt)
include(widgets/CMakeLists.txt)
include(workarearenderer/CMakeLists.txt)

target_link_libraries(synfigstudio
    ${GTKMM_LIBRARIES}
    ${Gettext_LIBRARIES}
    synfig
    synfigapp
)

install(
    TARGETS synfigstudio
    DESTINATION bin
)

=== synfig-core/src/modules/mod_bmp/CMakeLists.txt ===
add_library(mod_bmp MODULE "")

target_sources(mod_bmp
    PUBLIC
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/mptr_bmp.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/trgt_bmp.cpp"
)

target_link_libraries(mod_bmp synfig ${SIGCPP_LIBRARIES})

install (
    TARGETS mod_bmp
    DESTINATION lib/synfig/modules
)

=== synfig-core/src/modules/mod_example/CMakeLists.txt ===
add_library(mod_example MODULE "")

target_sources(mod_example
    PUBLIC
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/metaballs.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/simplecircle.cpp"
)

target_link_libraries(mod_example synfig)

install (
    TARGETS mod_example
    DESTINATION lib/synfig/modules
)

=== synfig-core/src/modules/mod_filter/CMakeLists.txt ===
add_library(mod_filter MODULE "")

target_sources(mod_filter
    PUBLIC
        "${CMAKE_CURRENT_LIST_DIR}/halftone3.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/blur.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/lumakey.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/halftone2.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/halftone.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/colorcorrect.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/radialblur.cpp"
)

target_link_libraries(mod_filter synfig ${CAIRO_LIBRARIES})

install (
    TARGETS mod_filter
    DESTINATION lib/synfig/modules
)

=== synfig-core/src/modules/mod_particle/CMakeLists.txt ===
add_library(mod_particle MODULE "")

target_sources(mod_particle
    PUBLIC
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/random.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/plant.cpp"
)

target_link_libraries(mod_particle synfig ${CAIRO_LIBRARIES})

install (
    TARGETS mod_particle
    DESTINATION lib/synfig/modules
)

=== synfig-core/src/modules/mod_png/CMakeLists.txt ===
add_library(mod_png MODULE "")

target_sources(mod_png
    PUBLIC
        "${CMAKE_CURRENT_LIST_DIR}/main.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/mptr_cairo_png.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/mptr_png.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/trgt_cairo_png.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/trgt_png_spritesheet.cpp"
        "${CMAKE_CURRENT_LIST_DIR}/trgt_png.cpp"
)

target_link_libraries(mod_png synfig ${LIBPNG_LIBRARIES})

install (
    TARGETS mod_png
    DESTINATION lib/synfig/modules
)

=== debian/changelog ===
synfig (1.4.2-0ubuntu1) unstable; urgency=medium

  * New upstream release.

 -- Chris <dpkg@chris-nz.com>  Tue, 07 Sep 2021 20:15:45 +1200

=== debian/control ===
Source: synfig
Section: graphics
Priority: optional
Standards-Version: 4.5.0
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
Build-Depends: debhelper-compat (= 12), autopoint, intltool
    ,binutils
    ,etl-dev (>= 1.4.2~)
    ,libavcodec-dev
    ,libavformat-dev
    ,libavutil-dev
    ,libboost-all-dev
    ,libcairo-dev
    ,libfftw3-dev
    ,libfontconfig1-dev
    ,libfreetype6-dev
    ,libgl1-mesa-dev
    ,libglibmm-2.4-dev
    ,libjpeg-dev
    ,libltdl-dev
    ,libmagick++-dev
    ,libmlt++-dev
    ,libmlt-dev
    ,libmng-dev
    ,libopenexr-dev
    ,libpango1.0-dev
    ,libpng-dev
    ,libsigc++-2.0-dev
    ,libswscale-dev
    ,libtiff-dev
    ,libxml++2.6-dev
Vcs-Browser: https://salsa.debian.org/multimedia-team/synfig
Vcs-Git: https://salsa.debian.org/multimedia-team/synfig.git
Homepage: http://www.synfig.org/
Rules-Requires-Root: no

Package: synfig
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: synfigstudio,
 synfig-examples
Description: vector-based 2D animation renderer
 synfig is a vector based 2D animation renderer. It is designed to be
 capable of producing feature-film quality animation.
 .
 This package contains the command-line renderer, for the GUI animation
 editor, please install synfigstudio.

Package: libsynfig0a
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libdv-bin,
# libav-tools,
 imagemagick
Breaks: synfigstudio (<< 0.64.2)
Conflicts: libsynfig0v5, libsynfig0
Replaces: libsynfig0v5, libsynfig0
Description: render library and plugins for synfig 2D animation
 synfig is a vector based 2D animation package. It is designed to be
 capable of producing feature-film quality animation.
 .
 This package contains the shared library and plugin modules for it.

Package: libsynfig-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends} ,libsynfig0a (= ${binary:Version})
    ,etl-dev (>= 1.4.0~)
    ,libavcodec-dev
    ,libavformat-dev
    ,libavutil-dev
    ,libcairo-dev
    ,libfftw3-dev
    ,libfontconfig1-dev
    ,libfreetype6-dev
    ,libglibmm-2.4-dev
    ,libmlt++-dev
    ,libopenexr-dev
    ,libpango1.0-dev
    ,libsigc++-2.0-dev
    ,libswscale-dev
    ,libxml++2.6-dev
Description: synfig library development files
 synfig is a vector based 2D animation package. It is designed to be
 capable of producing feature-film quality animation.
 .
 This package contains headers and other files needed to develop
 applications using the shared library and plugin modules.

Package: synfig-examples
Architecture: all
Multi-Arch: foreign
Suggests: synfigstudio
Conflicts: libsynfig-doc
Replaces: libsynfig-doc
Depends: ${misc:Depends}
Description: synfig animation examples
 synfig is a vector based 2D animation renderer. It is designed to be
 capable of producing feature-film quality animation.
 .
 This package contains several examples of synfig animations and stills.

## synfig 1.5.0

=== synfig-studio/src/CMakeLists.txt ===
##
## Find packages
##

## TODO: check version
if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_SOURCE_DIR}")
    find_package(synfig CONFIG REQUIRED)
endif()

find_package(Gettext)

if (Gettext_FOUND)
    set(ENABLE_NLS ON)
    set(GETTEXT_PACKAGE ${PROJECT_NAME})
endif()

if(VCPKG_TOOLCHAIN)
	set(GTKMM_LIBRARIES
		${ATK_LIBRARY} ${ATKMM_LIBRARY}
		${CAIROMM_LIBRARY}
		${GDK_LIBRARY}
		${GDKMM_LIBRARY}
		${GIOMM_LIBRARY}
		${GLIB_LIBRARIES}
		${GLIBMM_LIBRARY}
		${GTK_LIBRARY}
		${GTKMM_LIBRARY}
		${PANGOMM_LIBRARY}
	)
else()
	## TODO: check if we really need to find deps common with synfig core
	include(FindPkgConfig)
	if(PKG_CONFIG_FOUND)
		pkg_check_modules(SIGCPP REQUIRED sigc++-2.0)
		pkg_check_modules(GTKMM REQUIRED gtkmm-3.0)
		pkg_check_modules(LIBXML REQUIRED libxml++-2.6)
		pkg_check_modules(MLT mlt++) # required for widget_soundwave
	endif()

	foreach(pkg_config_lib SIGCPP GTKMM LIBXML MLT FFTW)
		include_directories(${${pkg_config_lib}_INCLUDE_DIRS})
		link_directories(${${pkg_config_lib}_LIBRARY_DIRS})
	endforeach()
endif()

if(FONT_CONFIG_FOUND)
	add_definitions(-DWITH_FONTCONFIG)
endif()

if (NOT MLT_FOUND)
	add_definitions(-DWITHOUT_MLT) # disable MLT if not found
endif()

##
## Config
##

if(FONT_CONFIG_FOUND)
add_definitions(-DWITH_FONTCONFIG)
endif()

add_definitions(-DHAVE_CONFIG_H)
configure_file(config.h.cmake.in config.h)

##
## Header include dirs
##

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

include_directories(
        ${SIGCPP_INCLUDE_DIRS}
        ${GTKMM_INCLUDE_DIRS}
)

##
## Search path for libs (needed to link with libsynfig)
##
link_directories(${CMAKE_PREFIX_PATH}/lib)

##
## Sub-directories
##

add_subdirectory(synfigapp)
add_subdirectory(gui)

=== synfig-core/src/synfig/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,23 @@
 ## TODO: optional static linking?
 add_library(synfig SHARED "")
 
+add_definitions(-DVERSION="${STUDIO_VERSION_MAJOR}.${STUDIO_VERSION_MINOR}.${STUDIO_VERSION_PATCH}")
+
 message(STATUS "MLT DIR: ${MLT_INCLUDE_DIRS}")
+
+# By default, the libtool places its headers in the system directory (/usr/local/include), and
+# compiler automatically finds ltdl.h header. But on MacOS, CMake overrides the system directory
+# using the `-sysroot` flag, and this header cannot be found. (https://gitlab.kitware.com/cmake/cmake/-/issues/19120)
+# So, we need to manually find it.
+
+if(APPLE OR VCPKG_TOOLCHAIN)
+    find_path(LTDL_INCLUDE_DIRS ltdl.h)
+    find_library(LTDL_LIBRARIES ltdl)
+    message(STATUS "Libltdl headers:   ${LTDL_INCLUDE_DIRS}")
+    message(STATUS "Libltdl libraries: ${LTDL_LIBRARIES}")
+else()
+    set(LTDL_LIBRARIES ltdl)
+endif()
 
 target_include_directories(synfig
 #    SYSTEM BEFORE PUBLIC
@@ -20,6 +36,7 @@
         ${PANGO_INCLUDE_DIRS}
         ${MLT_INCLUDE_DIRS}
         ${FFTW_INCLUDE_DIRS}
+        ${LTDL_INCLUDE_DIRS}
 )
 
 target_sources(synfig
@@ -27,8 +44,6 @@
         "${CMAKE_CURRENT_LIST_DIR}/activepoint.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/bone.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/blur.cpp"
-        "${CMAKE_CURRENT_LIST_DIR}/cairo_operators.cpp"
-        "${CMAKE_CURRENT_LIST_DIR}/cairo_renddesc.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/canvas.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/context.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/curve_helper.cpp"
@@ -37,7 +52,6 @@
         "${CMAKE_CURRENT_LIST_DIR}/exception.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/guid.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/importer.cpp"
-        "${CMAKE_CURRENT_LIST_DIR}/cairoimporter.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/keyframe.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/layer.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/loadcanvas.cpp"
@@ -85,14 +99,11 @@
         "${CMAKE_CURRENT_LIST_DIR}/target_null.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/target_null_tile.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/target_scanline.cpp"
-        "${CMAKE_CURRENT_LIST_DIR}/target_cairo.cpp"
         "${CMAKE_CURRENT_LIST_DIR}/target_tile.cpp"
-        "${CMAKE_CURRENT_LIST_DIR}/target_cairo_tile.cpp"
 )
 target_sources(synfig
     PRIVATE
         "${CMAKE_CURRENT_LIST_DIR}/listimporter.cpp"
-        "${CMAKE_CURRENT_LIST_DIR}/cairolistimporter.cpp"
 )
 target_sources(synfig
     PRIVATE
@@ -121,17 +132,15 @@
 target_link_libraries(synfig
     PUBLIC
         ${SIGCPP_LIBRARIES}
-        ${GLIBMM_LIBARIES}
+        ${GLIBMM_LIBRARIES}
         ${GIOMM_LIBRARIES}
-        ${CAIRO_LIBRARIES}
         ${LIBXML_LIBRARIES}
+        ${XMLPP_LIBRARIES}
         ${MLT_LIBRARIES}
         ${ZLIB_LIBRARIES}
         ${FFTW_LIBRARIES}
+        ${LTDL_LIBRARIES}
         ${CMAKE_THREAD_LIBS_INIT}
-
-        # TODO: properly detect ltdl
-        ltdl
 )
 
 ## Install headers

=== synfig-studio/src/gui/CMakeLists.txt ===
##
## Configure
##

set(STUDIO_VERSION "${STUDIO_VERSION_MAJOR}.${STUDIO_VERSION_MINOR}.${STUDIO_VERSION_PATCH}")
set(SHOW_EXTRA_INFO OFF) # this needs some fixes to work
set(DATA_PREFIX "${CMAKE_INSTALL_PREFIX}" CACHE PATH "Path, where the share directory with the pixmaps, sounds, plugins and translations is located. Default: Prefix, where Synfig Studio is going to be installed")
set(IMG_EXT "png" CACHE STRING "File extension of the pixmaps (without the \".\"). Default: png")

configure_file(autorevision.h.cmake.in autorevision.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

## Defines
set(SYNFIG_DATA_PREFIX "${DATA_PREFIX}/share/synfig")

add_definitions(-DIMAGE_EXT="${IMG_EXT}")
add_definitions(-DIMAGE_DIR="${DATA_PREFIX}/share/pixmaps")
add_definitions(-DSYNFIG_DATADIR="${SYNFIG_DATA_PREFIX}")
add_definitions(-DLOCALEDIR="${DATA_PREFIX}/share/locale")
add_definitions(-DCMAKE_BUILD)
add_definitions(-DDEVEL_VERSION="Revision date: ${GIT_DATE}\\nBranch: ${GIT_BRANCH}\\nRevision ID: ${GIT_HASH}")

if (CMAKE_BUILD_TYPE MATCHES Debug)
	add_definitions("-DSHOW_EXTRA_INFO")
	add_definitions(-DETL_VERSION="${ETL_VERSION}")
endif()

##
## Targets
##

if(MINGW)
	configure_file(synfigstudio.rc ${CMAKE_CURRENT_BINARY_DIR}/synfigstudio.rc)
	add_executable(synfigstudio main.cpp ${CMAKE_CURRENT_BINARY_DIR}/synfigstudio.rc)
else()
	add_executable(synfigstudio main.cpp)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

target_sources(synfigstudio
	PRIVATE
		"${CMAKE_CURRENT_LIST_DIR}/duck.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/timemodel.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/app.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/asyncrenderer.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/audiocontainer.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/autorecover.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/canvasview.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/devicetracker.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/dialogsettings.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/duckmatic.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/iconcontroller.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/instance.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/ipc.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/keymapsettings.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/onemoment.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/pluginmanager.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/preview.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/progresslogger.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/renddesc.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/render.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/resourcehelper.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/splash.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/statemanager.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/timeplotdata.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/valuelink.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/waypointrenderer.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/workarea.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/workspacehandler.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/main_win32.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/mainwindow.cpp"
		"${CMAKE_CURRENT_LIST_DIR}/helpers.cpp"
)

include(actionmanagers/CMakeLists.txt)
include(cellrenderer/CMakeLists.txt)
include(dialogs/CMakeLists.txt)
include(dials/CMakeLists.txt)
include(docks/CMakeLists.txt)
include(modules/CMakeLists.txt)
include(states/CMakeLists.txt)
include(trees/CMakeLists.txt)
include(widgets/CMakeLists.txt)
include(workarearenderer/CMakeLists.txt)

add_subdirectory(resources)

target_include_directories(synfigstudio PRIVATE ${MLT_INCLUDE_DIRS}) # required for widget_soundwave

# on MacOS/Brew FontConfig located in non-standard folder
# so we need to add it's path to target
target_link_libraries(synfigstudio
	${FONT_CONFIG_LDFLAGS}
	${GTKMM_LIBRARIES}
	${Gettext_LIBRARIES}
	${MLT_LIBRARIES} # required for widget_soundwave
	${LIBXML_LIBRARIES} # required for gui/pluginmanager
	${FONT_CONFIG_LIBRARIES}
	synfig
	synfigapp
)

install(
	TARGETS synfigstudio
	DESTINATION bin
)

=== debian/changelog ===
synfig (1.5.0-0ubuntu1) groovy; urgency=medium

  * New upstream release.

 -- Chris <dpkg@chris-nz.com>  Tue, 07 Sep 2021 16:15:05 +1200
